CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes
PMESource Class Reference

`#include <PME.h>`

List of all members.

## Public Member Functions
void | set_position (CPoint &P)
CPoint | get_position ()
void | update_position ()
void | set_orbit (CPoint &R, CPoint &V)
MovementType | get_current_move_type ()
MovementType | get_next_move_type ()
void | update_move_type ()
void | set_next_move_type (MovementType mov_type)
void | set_current_move_type (MovementType mov_type)
void | push_trace (CPoint &pos)
void | reset_trace ()
void | set_bounce_velocity (CPoint bv)
void | set_bounce_distance (float bd)
| PMESource (SpatialSource &s)
| PMESource ()
| ~PMESource ()

## Protected Attributes
SpatialSource * | source
Orbit | orbit
MovementType | current_move_type
MovementType | next_move_type
CPoint | trace [MAX_TRACE_LENGTH]
float | bounce_distance
CPoint | bounce_velocity
unsigned | current_trace_index
unsigned | trace_length

## Detailed Description

Definition at line 104 of file PME.h.

## Constructor & Destructor Documentation

PMESource::PMESource | ( | SpatialSource & | s | ) |

Definition at line 90 of file PME.cpp.

PMESource::PMESource | ( |  | ) |

Definition at line 94 of file PME.cpp.

PMESource::~PMESource | ( |  | ) |
| inline

Definition at line 133 of file PME.h.

## Member Function Documentation

void PMESource::set_position | ( | CPoint & | P | ) |

Definition at line 98 of file PME.cpp.

References csl::SpatialSource::setPosition(), and source.

Referenced by PME::update_grabbed_position().

CPoint PMESource::get_position | ( |  | ) |

Definition at line 102 of file PME.cpp.

References csl::SpatialSource::getPosition(), and source.

Referenced by PME::check_for_grabbed_source().

void PMESource::update_position | ( |  | ) |

Definition at line 106 of file PME.cpp.

References bounce_distance, bounce_velocity, Orbit::calculate_absolute_position(), Orbit::calculate_new_position_in_orbit(), current_move_type, current_trace_index, csl::SpatialSource::getPosition(), kBounce, kDraw, kGrabbed, kOrbit, kStopped, orbit, csl::SpatialSource::setPosition(), signof, source, trace, trace_length, csl::CPoint::x, csl::CPoint::y, and csl::CPoint::z.

Referenced by PME::manage_sources().

void PMESource::set_orbit | ( | CPoint & | R,
|  | CPoint & | V
| ) |  |

Definition at line 154 of file PME.cpp.

References Orbit::calculate_orbital_params(), and orbit.

Referenced by PME::manage_sources().

MovementType PMESource::get_current_move_type | ( |  | ) |
| inline

Definition at line 121 of file PME.h.

Referenced by PME::manage_sources().

MovementType PMESource::get_next_move_type | ( |  | ) |
| inline

Definition at line 122 of file PME.h.

Referenced by PME::manage_sources().

void PMESource::update_move_type | ( |  | ) |
| inline

Definition at line 123 of file PME.h.

Referenced by PME::manage_sources().

void PMESource::set_next_move_type | ( | MovementType | mov_type | ) |

Definition at line 158 of file PME.cpp.

References next_move_type.

void PMESource::set_current_move_type | ( | MovementType | mov_type | ) |

Definition at line 162 of file PME.cpp.

References current_move_type.

Referenced by PME::check_for_grabbed_source(), and PME::manage_sources().

void PMESource::push_trace | ( | CPoint & | pos | ) |

Definition at line 170 of file PME.cpp.

References MAX_TRACE_LENGTH, trace, and trace_length.

Referenced by PME::manage_sources().

void PMESource::reset_trace | ( |  | ) |
| inline

Definition at line 127 of file PME.h.

Referenced by PME::manage_sources().

void PMESource::set_bounce_velocity | ( | CPoint | bv | ) |
| inline

Definition at line 128 of file PME.h.

Referenced by PME::manage_sources().

void PMESource::set_bounce_distance | ( | float | bd | ) |

Definition at line 166 of file PME.cpp.

References bounce_distance.

## Member Data Documentation

SpatialSource* PMESource::source
| protected

Definition at line 106 of file PME.h.

Referenced by get_position(), set_position(), and update_position().

Orbit PMESource::orbit
| protected

Definition at line 107 of file PME.h.

Referenced by set_orbit(), and update_position().

MovementType PMESource::current_move_type
| protected

Definition at line 108 of file PME.h.

Referenced by set_current_move_type(), and update_position().

MovementType PMESource::next_move_type
| protected

Definition at line 109 of file PME.h.

Referenced by set_next_move_type().

CPoint PMESource::trace[MAX_TRACE_LENGTH]
| protected

Definition at line 110 of file PME.h.

Referenced by push_trace(), and update_position().

float PMESource::bounce_distance
| protected

Definition at line 111 of file PME.h.

Referenced by set_bounce_distance(), and update_position().

CPoint PMESource::bounce_velocity
| protected

Definition at line 112 of file PME.h.

Referenced by update_position().

unsigned PMESource::current_trace_index
| protected

Definition at line 113 of file PME.h.

Referenced by update_position().

unsigned PMESource::trace_length
| protected

Definition at line 114 of file PME.h.

Referenced by push_trace(), and update_position().

The documentation for this class was generated from the following files:

- CSL/Spatializers/VBAP/PME.h
- CSL/Spatializers/VBAP/PME.cpp